rnd = math.random
math.randomseed(os.time())


Cloud = {}
function Cloud:new(i, s, x, y, dx)
	local t = {i = i, scale = s, x = x, y = y, dx = dx}
	setmetatable(t, {__index = self})
	return t
end
function Cloud:move(dt)
	self.x = self.x + self.dx * dt
end
function Cloud:draw()
	love.graphics.draw(cloud_imgs[self.i], self.x, self.y, 0, self.scale)
end

function _neg(x)
	return x*(rnd(0, 1) == 0 and -1 or 1)
end

function DefaultCloud()
	return Cloud:new(rnd(#cloud_imgs), .5+rnd()*.5, rnd(-50, 850), rnd(50, 500), _neg(rnd(2, 10)))
end
function NewCloud()
	local n = _neg(1)
	local s = .5+rnd()*.5
	return Cloud:new(rnd(#cloud_imgs), s, 400-n*(400+s*320), rnd(-100, 500), n*rnd(2, 10))
end


function Cloud:load()
	cloud_imgs = {
					love.graphics.newImage("img/cloud1.png"),
					love.graphics.newImage("img/cloud2.png"),
					love.graphics.newImage("img/cloud3.png"),
					love.graphics.newImage("img/cloud4.png"),
					love.graphics.newImage("img/cloud5.png")}
	local n = rnd(2,7)
	cloud_data = {n = n}
	for i=1,n do
		cloud_data[i] = DefaultCloud()
	end
	love.graphics.setBackgroundColor(16, 159, 230)
end

function Cloud:update(dt)
	for i=1,cloud_data.n do
		cloud_data[i]:move(dt)
	end
	if rnd() < .002 and cloud_data.n <= 10 then --.2% chance of new cloud, and don't make too many clouds
		cloud_data.n = cloud_data.n + 1
		cloud_data[cloud_data.n] = NewCloud() --added new cloud
	end
	for i=1,cloud_data.n do --garbage collection
		if math.abs(cloud_data[i].x-400+160) > (400+cloud_data[i].scale*160) then
			cloud_data[i] = cloud_data[cloud_data.n] --last cloud replaces cloud due for deletion
			cloud_data.n = cloud_data.n - 1
		end
	end
	if cloud_data.n == 0 then error("All clouds gone!") end
end

function Cloud:drawall()
	for i=1,cloud_data.n do
		cloud_data[i]:draw()
	end
end
